/*
 * $Id: spider.h,v 1.5 2005/01/11 17:19:00 pdclose Exp $
 *
 * Copyright  2002, 2003, 2004, 2005 Paul Close
 * 
 * This software is released as OSI Certified Open Source under the
 * Artistic License (see LICENSE.txt) http://www.opensource.org/
 * 
 * THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Copyright  1998 Keith Packard
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Keith Packard not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Keith Packard makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

extern CardBool
SpiderSelectTable (CardStackIndex   stack,
		   CardIndex	    *first,
		   CardIndex	    *last) GAME_SECT;

extern CardProgressType
SpiderCheckTable (CardStackIndex    src, 
		  CardStackIndex    dst,
		  CardIndex	    card) GAME_SECT;

extern CardProgressType
SpiderCheckEmpty (CardStackIndex    src, 
		  CardStackIndex    dst,
		  CardIndex	    card) GAME_SECT;

extern CardProgressType
SpiderCheckSuitTable (CardStackIndex	src, 
		      CardStackIndex	dst,
		      CardIndex		card) GAME_SECT;

extern CardProgressType
SpiderCheckPile (CardStackIndex src, 
		 CardStackIndex dst,
		 CardIndex	card) GAME_SECT;

extern CardSetupType	SpiderSetup[];

#define SpiderDeck	0
#define SpiderPile	(SpiderDeck + 1)
#define SpiderNpile	8
#define SpiderLpile	(SpiderPile + SpiderNpile - 1)
#define SpiderTable	(SpiderLpile + 1)
#define SpiderNtable	10
#define SpiderLtable	(SpiderTable + SpiderNtable - 1)
#define SpiderNstack	(SpiderLtable + 1)

